#region Using

using System;
using System.Web;
using System.Text.RegularExpressions;

#endregion

/// <summary>
/// Removes the www subdomain from all requests
/// and makes a permanent redirection to the new location.
/// </summary>
public class RemoveWwwModule : IHttpModule
{

  #region IHttpModule Members

  public void Dispose()
  {
    // Nothing to dispose
  }

  public void Init(HttpApplication context)
  {
    context.BeginRequest += new EventHandler(context_BeginRequest);
  }

  #endregion

  private static Regex _Regex = new Regex("(http|https)://www\\.", RegexOptions.IgnoreCase | RegexOptions.Compiled);

  private void context_BeginRequest(object sender, EventArgs e)
  {    
    HttpContext context = (sender as HttpApplication).Context;
    if (context.Request.PhysicalPath.EndsWith(".aspx", StringComparison.OrdinalIgnoreCase))
    {
      string url = context.Request.RawUrl;

      if (_Regex.IsMatch(url))
      {
        url = _Regex.Replace(url, "$1://");
        context.Response.Redirect(url);
      }
    }
  }

}
